Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10090)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10091)
@@ -129,5 +129,5 @@
     <Compile Include="ISolutionCache.cs" />
     <Compile Include="PermutationEncoding\PermutationSolutionCache.cs" />
-    <Compile Include="PermutationEncoding\PermutationSolutionCachingAnalyzer.cs" />
+    <Compile Include="PermutationEncoding\PermutationSolutionCacheCollector.cs" />
     <Compile Include="PermutationEncoding\PermutationSolutionInformation.cs" />
     <Compile Include="Plugin.cs" />
@@ -135,5 +135,5 @@
     <Compile Include="RealVectorEncoding\RealVectorEqualityComparer.cs" />
     <Compile Include="RealVectorEncoding\RealVectorSolutionCache.cs" />
-    <Compile Include="RealVectorEncoding\RealVectorSolutionCachingAnalyzer.cs" />
+    <Compile Include="RealVectorEncoding\RealVectorSolutionCacheCollector.cs" />
     <Compile Include="RealVectorEncoding\RealVectorSolutionInformation.cs" />
     <Compile Include="SolutionCache.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionCacheCollector.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionCacheCollector.cs	(revision 10091)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionCacheCollector.cs	(revision 10091)
@@ -0,0 +1,100 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.SolutionCaching.PermutationEncoding {
+  [Item("PermutationSolutionCacheCollector", "An operator that records all Permutation solutions every generation for GAs.")]
+  [StorableClass]
+  public class PermutationSolutionCacheCollector : SingleSuccessorOperator, IAnalyzer {
+    private const string ResultsParameterName = "Results";
+
+    #region IAnalyzer Members
+    public bool EnabledByDefault {
+      get { return false; }
+    }
+    #endregion
+
+    #region Parameter properties
+    public ILookupParameter<ResultCollection> ResultsParameter {
+      get { return (ILookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
+    }
+    public ILookupParameter<IntValue> GenerationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["Generations"]; }
+    }
+    public ScopeTreeLookupParameter<Permutation> SolutionParameter {
+      get { return (ScopeTreeLookupParameter<Permutation>)Parameters["Solution"]; }
+    }
+    #endregion
+
+    #region Properties
+    public ResultCollection Results {
+      get { return ResultsParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private PermutationSolutionCacheCollector(bool deserializing) : base(deserializing) { }
+
+    private PermutationSolutionCacheCollector(PermutationSolutionCacheCollector original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public PermutationSolutionCacheCollector()
+      : base() {
+      Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
+      Parameters.Add(new LookupParameter<IntValue>("Generations", "Nr of generations."));
+      Parameters.Add(new ScopeTreeLookupParameter<Permutation>("Solution", "The solutions that should be stored.", "TSPTour", 1));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationSolutionCacheCollector(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      ItemArray<Permutation> solutions = SolutionParameter.ActualValue;
+      PermutationSolutionCache solDict;
+
+      if (!Results.ContainsKey("SolutionCache")) {
+        solDict = new PermutationSolutionCache();
+        Results.Add(new Result("SolutionCache", solDict));
+      } else {
+        solDict = (PermutationSolutionCache)Results["SolutionCache"].Value;
+      }
+
+      foreach (var sol in solutions) {
+        PermutationSolutionInformation info = new PermutationSolutionInformation();
+        info.Generation = GenerationsParameter.ActualValue.Value;
+        info.ProducedBy = ProducedBy.CrossoverAndMutation;
+
+        solDict.Add((Permutation)sol.Clone(new Cloner()), info);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionCachingAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionCachingAnalyzer.cs	(revision 10090)
+++ 	(revision )
@@ -1,100 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Analysis.SolutionCaching.PermutationEncoding {
-  [Item("PermutationSolutionCachingAnalyzer", "An operator that records all Permutation solutions every generation for GAs.")]
-  [StorableClass]
-  public class PermutationSolutionCachingAnalyzer : SingleSuccessorOperator, IAnalyzer {
-    private const string ResultsParameterName = "Results";
-
-    #region IAnalyzer Members
-    public bool EnabledByDefault {
-      get { return false; }
-    }
-    #endregion
-
-    #region Parameter properties
-    public ILookupParameter<ResultCollection> ResultsParameter {
-      get { return (ILookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
-    }
-    public ILookupParameter<IntValue> GenerationsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["Generations"]; }
-    }
-    public ScopeTreeLookupParameter<Permutation> SolutionParameter {
-      get { return (ScopeTreeLookupParameter<Permutation>)Parameters["Solution"]; }
-    }
-    #endregion
-
-    #region Properties
-    public ResultCollection Results {
-      get { return ResultsParameter.ActualValue; }
-    }
-    #endregion
-
-    [StorableConstructor]
-    private PermutationSolutionCachingAnalyzer(bool deserializing) : base(deserializing) { }
-
-    private PermutationSolutionCachingAnalyzer(PermutationSolutionCachingAnalyzer original, Cloner cloner)
-      : base(original, cloner) {
-    }
-
-    public PermutationSolutionCachingAnalyzer()
-      : base() {
-      Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
-      Parameters.Add(new LookupParameter<IntValue>("Generations", "Nr of generations."));
-      Parameters.Add(new ScopeTreeLookupParameter<Permutation>("Solution", "The solutions that should be stored.", "TSPTour", 1));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PermutationSolutionCachingAnalyzer(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      ItemArray<Permutation> solutions = SolutionParameter.ActualValue;
-      PermutationSolutionCache solDict;
-
-      if (!Results.ContainsKey("SolutionCache")) {
-        solDict = new PermutationSolutionCache();
-        Results.Add(new Result("SolutionCache", solDict));
-      } else {
-        solDict = (PermutationSolutionCache)Results["SolutionCache"].Value;
-      }
-
-      foreach (var sol in solutions) {
-        PermutationSolutionInformation info = new PermutationSolutionInformation();
-        info.Generation = GenerationsParameter.ActualValue.Value;
-        info.ProducedBy = ProducedBy.CrossoverAndMutation;
-
-        solDict.Add((Permutation)sol.Clone(new Cloner()), info);
-      }
-      return base.Apply();
-    }
-  }
-}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionCacheCollector.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionCacheCollector.cs	(revision 10091)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionCacheCollector.cs	(revision 10091)
@@ -0,0 +1,100 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding {
+  [Item("RealVectorSolutionCacheCollector", "An operator that records all RealVector solutions every generation for GAs.")]
+  [StorableClass]
+  public class RealVectorSolutionCacheCollector : SingleSuccessorOperator, IAnalyzer {
+    private const string ResultsParameterName = "Results";
+
+    #region IAnalyzer Members
+    public bool EnabledByDefault {
+      get { return false; }
+    }
+    #endregion
+
+    #region Parameter properties
+    public ILookupParameter<ResultCollection> ResultsParameter {
+      get { return (ILookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
+    }
+    public ILookupParameter<IntValue> GenerationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["Generations"]; }
+    }
+    public ScopeTreeLookupParameter<RealVector> SolutionParameter {
+      get { return (ScopeTreeLookupParameter<RealVector>)Parameters["Solution"]; }
+    }
+    #endregion
+
+    #region Properties
+    public ResultCollection Results {
+      get { return ResultsParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private RealVectorSolutionCacheCollector(bool deserializing) : base(deserializing) { }
+
+    private RealVectorSolutionCacheCollector(RealVectorSolutionCacheCollector original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public RealVectorSolutionCacheCollector()
+      : base() {
+      Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
+      Parameters.Add(new LookupParameter<IntValue>("Generations", "Nr of generations."));
+      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("Solution", "The solutions that should be stored.", "Point", 1));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorSolutionCacheCollector(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      ItemArray<RealVector> solutions = SolutionParameter.ActualValue;
+      RealVectorSolutionCache solDict;
+
+      if (!Results.ContainsKey("SolutionCache")) {
+        solDict = new RealVectorSolutionCache();
+        Results.Add(new Result("SolutionCache", solDict));
+      } else {
+        solDict = (RealVectorSolutionCache)Results["SolutionCache"].Value;
+      }
+
+      foreach (var sol in solutions) {
+        RealVectorSolutionInformation info = new RealVectorSolutionInformation();
+        info.Generation = GenerationsParameter.ActualValue.Value;
+        info.ProducedBy = ProducedBy.CrossoverAndMutation;
+
+        solDict.Add((RealVector)sol.Clone(new Cloner()), info);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionCachingAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionCachingAnalyzer.cs	(revision 10090)
+++ 	(revision )
@@ -1,100 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.RealVectorEncoding;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding {
-  [Item("RealVectorSolutionCachingAnalyzer", "An operator that records all RealVector solutions every generation for GAs.")]
-  [StorableClass]
-  public class RealVectorSolutionCachingAnalyzer : SingleSuccessorOperator, IAnalyzer {
-    private const string ResultsParameterName = "Results";
-
-    #region IAnalyzer Members
-    public bool EnabledByDefault {
-      get { return false; }
-    }
-    #endregion
-
-    #region Parameter properties
-    public ILookupParameter<ResultCollection> ResultsParameter {
-      get { return (ILookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
-    }
-    public ILookupParameter<IntValue> GenerationsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["Generations"]; }
-    }
-    public ScopeTreeLookupParameter<RealVector> SolutionParameter {
-      get { return (ScopeTreeLookupParameter<RealVector>)Parameters["Solution"]; }
-    }
-    #endregion
-
-    #region Properties
-    public ResultCollection Results {
-      get { return ResultsParameter.ActualValue; }
-    }
-    #endregion
-
-    [StorableConstructor]
-    private RealVectorSolutionCachingAnalyzer(bool deserializing) : base(deserializing) { }
-
-    private RealVectorSolutionCachingAnalyzer(RealVectorSolutionCachingAnalyzer original, Cloner cloner)
-      : base(original, cloner) {
-    }
-
-    public RealVectorSolutionCachingAnalyzer()
-      : base() {
-      Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
-      Parameters.Add(new LookupParameter<IntValue>("Generations", "Nr of generations."));
-      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("Solution", "The solutions that should be stored.", "Point", 1));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new RealVectorSolutionCachingAnalyzer(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      ItemArray<RealVector> solutions = SolutionParameter.ActualValue;
-      RealVectorSolutionCache solDict;
-
-      if (!Results.ContainsKey("SolutionCache")) {
-        solDict = new RealVectorSolutionCache();
-        Results.Add(new Result("SolutionCache", solDict));
-      } else {
-        solDict = (RealVectorSolutionCache)Results["SolutionCache"].Value;
-      }
-
-      foreach (var sol in solutions) {
-        RealVectorSolutionInformation info = new RealVectorSolutionInformation();
-        info.Generation = GenerationsParameter.ActualValue.Value;
-        info.ProducedBy = ProducedBy.CrossoverAndMutation;
-
-        solDict.Add((RealVector)sol.Clone(new Cloner()), info);
-      }
-      return base.Apply();
-    }
-  }
-}