Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10091)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10096)
@@ -127,4 +127,6 @@
     <Compile Include="Algorithm\SolutionCacheAnalyzerAlgorithm.cs" />
     <Compile Include="Algorithm\ParallelOperatorProcessor.cs" />
+    <Compile Include="IAdvice.cs" />
+    <Compile Include="IPointcut.cs" />
     <Compile Include="ISolutionCache.cs" />
     <Compile Include="PermutationEncoding\PermutationSolutionCache.cs" />
@@ -133,4 +135,7 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="RealVectorEncoding\IRealVectorAdvice.cs" />
+    <Compile Include="RealVectorEncoding\IRealVectorPointcut.cs" />
+    <Compile Include="RealVectorEncoding\RealVectorCrossoverPointcut.cs" />
     <Compile Include="RealVectorEncoding\RealVectorEqualityComparer.cs" />
     <Compile Include="RealVectorEncoding\RealVectorSolutionCache.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/IAdvice.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/IAdvice.cs	(revision 10096)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/IAdvice.cs	(revision 10096)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Analysis.SolutionCaching {
+  public interface IAdvice : IOperator {
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/IPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/IPointcut.cs	(revision 10096)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/IPointcut.cs	(revision 10096)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Analysis.SolutionCaching {
+  public interface IPointcut : IItem {
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionInformation.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionInformation.cs	(revision 10091)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationSolutionInformation.cs	(revision 10096)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -30,7 +29,5 @@
   [StorableClass]
   public class PermutationSolutionInformation : SolutionInformation<Encodings.PermutationEncoding.Permutation> {
-    public PermutationSolutionInformation() {
-      ParentList = new List<Permutation>();
-    }
+    public PermutationSolutionInformation() : base() { }
     [StorableConstructor]
     protected PermutationSolutionInformation(bool deserializing) : base(deserializing) { }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/IRealVectorAdvice.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/IRealVectorAdvice.cs	(revision 10096)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/IRealVectorAdvice.cs	(revision 10096)
@@ -0,0 +1,25 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding {
+  public interface IRealVectorAdvice : IAdvice {
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/IRealVectorPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/IRealVectorPointcut.cs	(revision 10096)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/IRealVectorPointcut.cs	(revision 10096)
@@ -0,0 +1,25 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding {
+  public interface IRealVectorPointcut : IPointcut {
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorCrossoverPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorCrossoverPointcut.cs	(revision 10096)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorCrossoverPointcut.cs	(revision 10096)
@@ -0,0 +1,124 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Analysis.SolutionCaching.RealVectorEncoding {
+  [Item("RealVectorCrossoverPointcut", "Wraps a crossover and applies after-crossover actions.")]
+  [StorableClass]
+  public class RealVectorCrossoverPointcut : SingleSuccessorOperator, IRealVectorCrossover, IStochasticOperator, IRealVectorPointcut {
+    private const string AdviceParameterName = "Advice";
+    private const string CrossoversParameterName = "Crossovers";
+
+    public ConstrainedValueParameter<IRealVectorCrossover> CrossoversParameter {
+      get { return (ConstrainedValueParameter<IRealVectorCrossover>)Parameters[CrossoversParameterName]; }
+    }
+    public ConstrainedValueParameter<IRealVectorAdvice> AdviceParameter {
+      get { return (ConstrainedValueParameter<IRealVectorAdvice>)Parameters[AdviceParameterName]; }
+    }
+    public ILookupParameter<ItemArray<RealVector>> ParentsParameter {
+      get { return (ScopeTreeLookupParameter<RealVector>)Parameters["Parents"]; }
+    }
+    public ILookupParameter<RealVector> ChildParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["Child"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    [StorableConstructor]
+    protected RealVectorCrossoverPointcut(bool deserializing) : base(deserializing) { }
+    protected RealVectorCrossoverPointcut(RealVectorCrossoverPointcut original, Cloner cloner) : base(original, cloner) { }
+
+    public RealVectorCrossoverPointcut()
+      : base() {
+      var cxs = new ConstrainedValueParameter<IRealVectorCrossover>(CrossoversParameterName, "The crossovers.");
+      //Would be nicer if it comes from operator collection, but MultiRealVector Crossover does the same thing.
+      //Also: MultiRealVectorCrossover cannot be used here as it would generate a cyclic recursion 
+      //MultiRealVectorCrossover discovers RealVectorCrossoverPointcut which discovers Multi....
+      foreach (Type t in ApplicationManager.Manager.GetTypes(typeof(IRealVectorCrossover))) {
+        if ((!typeof(RealVectorCrossoverPointcut).IsAssignableFrom(t)) &&
+          (!typeof(MultiOperator<IRealVectorCrossover>).IsAssignableFrom(t))) {
+          cxs.ValidValues.Add((IRealVectorCrossover)Activator.CreateInstance(t));
+        }
+      }
+      Parameters.Add(cxs);
+
+      var advices = new ConstrainedValueParameter<IRealVectorAdvice>(AdviceParameterName,
+        "Advice to introduce after crossover");
+      foreach (var a in ApplicationManager.Manager.GetInstances<IRealVectorAdvice>()) {
+        advices.ValidValues.Add(a);
+      }
+      Parameters.Add(advices);
+
+      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("Parents", "The parent vectors which should be crossed."));
+      ParentsParameter.ActualName = "RealVector";
+      Parameters.Add(new LookupParameter<RealVector>("Child", "The child vector resulting from the crossover."));
+      ChildParameter.ActualName = "RealVector";
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds of the real vector."));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+
+      ParameterizeCrossovers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorCrossoverPointcut(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IOperation successor = base.Apply();
+      IOperation crossoverOperation = ExecutionContext.CreateChildOperation(CrossoversParameter.Value);
+      IOperation adviceOperation = ExecutionContext.CreateChildOperation(AdviceParameter.Value);
+
+      var opCol = new OperationCollection();
+      opCol.Add(crossoverOperation);
+      opCol.Add(adviceOperation);
+      if (successor != null)
+        opCol.Add(successor);
+
+      return opCol;
+    }
+
+    private void ParameterizeCrossovers() {
+      foreach (IRealVectorCrossover crossover in CrossoversParameter.ValidValues.OfType<IRealVectorCrossover>()) {
+        crossover.ChildParameter.ActualName = ChildParameter.Name;
+        crossover.ParentsParameter.ActualName = ParentsParameter.Name;
+        crossover.BoundsParameter.ActualName = BoundsParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in CrossoversParameter.ValidValues.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionInformation.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionInformation.cs	(revision 10091)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorSolutionInformation.cs	(revision 10096)
@@ -20,8 +20,6 @@
 #endregion
 
-using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -30,7 +28,5 @@
   [StorableClass]
   public class RealVectorSolutionInformation : SolutionInformation<Encodings.RealVectorEncoding.RealVector> {
-    public RealVectorSolutionInformation() {
-      ParentList = new List<RealVector>();
-    }
+    public RealVectorSolutionInformation() : base() { }
     [StorableConstructor]
     protected RealVectorSolutionInformation(bool deserializing) : base(deserializing) { }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/SolutionInformation.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/SolutionInformation.cs	(revision 10091)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/SolutionInformation.cs	(revision 10096)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -37,6 +38,11 @@
     [Storable]
     public int Generation { get; set; }
+    [Storable]
+    public ResultCollection InfoStore { get; set; }
 
-    public SolutionInformation() { }
+    public SolutionInformation() {
+      ParentList = new List<T>();
+      InfoStore = new ResultCollection();
+    }
 
     [StorableConstructor]
@@ -47,4 +53,5 @@
       this.ParentList = new List<T>(original.ParentList);
       this.Generation = original.Generation;
+      this.InfoStore = (ResultCollection)original.InfoStore.Clone(cloner);
     }
 
@@ -66,4 +73,7 @@
           if (!pi.ParentList.Contains(p)) return false;
         }
+        foreach (IResult info in InfoStore) {
+          if (!pi.InfoStore.Contains(info)) return false;
+        }
         return true;
       } else {
@@ -71,4 +81,8 @@
       }
     }
+
+    public virtual void AddInfo(Result info) {
+      InfoStore.Add(info);
+    }
   }
 }