Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterCrossoverCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterCrossoverCombinedOperator.cs	(revision 10098)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterCrossoverCombinedOperator.cs	(revision 10101)
@@ -20,4 +20,5 @@
 #endregion
 
+using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("QAPAfterCrossoverCombinedOperator", "An operator that contains all operators that need to be executed after crossover for the QAP.")]
   [StorableClass]
-  public class QAPAfterCrossoverCombinedOperator : AfterCrossoverCombinedOperator {
+  public class QAPAfterCrossoverCombinedOperator : AfterCrossoverCombinedOperator, IPermutationAdvice {
 
     [StorableConstructor]
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TSPAfterCrossoverCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TSPAfterCrossoverCombinedOperator.cs	(revision 10098)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TSPAfterCrossoverCombinedOperator.cs	(revision 10101)
@@ -20,4 +20,5 @@
 #endregion
 
+using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("TSPAfterCrossoverCombinedOperator", "An operator that contains all operators that need to be executed after crossover for the TSP.")]
   [StorableClass]
-  public class TSPAfterCrossoverCombinedOperator : AfterCrossoverCombinedOperator {
+  public class TSPAfterCrossoverCombinedOperator : AfterCrossoverCombinedOperator, IPermutationAdvice {
     [StorableConstructor]
     protected TSPAfterCrossoverCombinedOperator(bool deserializing) : base(deserializing) { }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/CrossoverPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/CrossoverPointcut.cs	(revision 10101)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/CrossoverPointcut.cs	(revision 10101)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Analysis.SolutionCaching {
+  [StorableClass]
+  public abstract class CrossoverPointcut<TA, TC> : SingleSuccessorOperator, ICrossover, IStochasticOperator, IPointcut
+    where TA : class, IAdvice
+    where TC : class, ICrossover {
+    protected const string AdviceParameterName = "Advice";
+    protected const string CrossoversParameterName = "Crossovers";
+
+    public ConstrainedValueParameter<TC> CrossoversParameter {
+      get { return (ConstrainedValueParameter<TC>)Parameters[CrossoversParameterName]; }
+    }
+    public ConstrainedValueParameter<TA> AdviceParameter {
+      get { return (ConstrainedValueParameter<TA>)Parameters[AdviceParameterName]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    [StorableConstructor]
+    protected CrossoverPointcut(bool deserializing) : base(deserializing) { }
+    protected CrossoverPointcut(CrossoverPointcut<TA, TC> original, Cloner cloner) : base(original, cloner) { }
+
+    public CrossoverPointcut()
+      : base() {
+      var advices = new ConstrainedValueParameter<TA>(AdviceParameterName,
+        "Advice to introduce after crossover");
+      foreach (var a in ApplicationManager.Manager.GetInstances<TA>()) {
+        advices.ValidValues.Add(a);
+      }
+      Parameters.Add(advices);
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new ConstrainedValueParameter<TC>(CrossoversParameterName, "The crossovers."));
+    }
+
+    public override IOperation Apply() {
+      IOperation successor = base.Apply();
+      IOperation crossoverOperation = ExecutionContext.CreateChildOperation(CrossoversParameter.Value);
+      IOperation adviceOperation = ExecutionContext.CreateChildOperation(AdviceParameter.Value);
+
+      var opCol = new OperationCollection();
+      opCol.Add(crossoverOperation);
+      opCol.Add(adviceOperation);
+      if (successor != null)
+        opCol.Add(successor);
+
+      return opCol;
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10098)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/HeuristicLab.Analysis.SolutionCaching-3.3.csproj	(revision 10101)
@@ -127,7 +127,11 @@
     <Compile Include="Algorithm\SolutionCacheAnalyzerAlgorithm.cs" />
     <Compile Include="Algorithm\ParallelOperatorProcessor.cs" />
+    <Compile Include="CrossoverPointcut.cs" />
     <Compile Include="IAdvice.cs" />
     <Compile Include="IPointcut.cs" />
     <Compile Include="ISolutionCache.cs" />
+    <Compile Include="PermutationEncoding\IPermutationAdvice.cs" />
+    <Compile Include="PermutationEncoding\IPermutationPointcut.cs" />
+    <Compile Include="PermutationEncoding\PermutationCrossoverPointcut.cs" />
     <Compile Include="PermutationEncoding\PermutationSolutionCache.cs" />
     <Compile Include="PermutationEncoding\PermutationSolutionCacheCollector.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/IPermutationAdvice.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/IPermutationAdvice.cs	(revision 10101)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/IPermutationAdvice.cs	(revision 10101)
@@ -0,0 +1,25 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.SolutionCaching.PermutationEncoding {
+  public interface IPermutationAdvice : IAdvice {
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/IPermutationPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/IPermutationPointcut.cs	(revision 10101)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/IPermutationPointcut.cs	(revision 10101)
@@ -0,0 +1,25 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.SolutionCaching.PermutationEncoding {
+  public interface IPermutationPointcut : IPointcut {
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationCrossoverPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationCrossoverPointcut.cs	(revision 10101)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/PermutationEncoding/PermutationCrossoverPointcut.cs	(revision 10101)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Analysis.SolutionCaching.PermutationEncoding {
+  [Item("PermutationCrossoverPointcut", "Wraps a crossover and applies after-crossover actions.")]
+  [StorableClass]
+  public class PermutationCrossoverPointcut : CrossoverPointcut<IPermutationAdvice, IPermutationCrossover>, IPermutationCrossover, IPermutationPointcut {
+    public ILookupParameter<ItemArray<Permutation>> ParentsParameter {
+      get { return (ILookupParameter<ItemArray<Permutation>>)Parameters["Parents"]; }
+    }
+    public ILookupParameter<Permutation> ChildParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["Child"]; }
+    }
+
+    [StorableConstructor]
+    protected PermutationCrossoverPointcut(bool deserializing) : base(deserializing) { }
+    protected PermutationCrossoverPointcut(PermutationCrossoverPointcut original, Cloner cloner) : base(original, cloner) { }
+
+    public PermutationCrossoverPointcut()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<Permutation>("Parents", "The parent permutations which should be crossed."));
+      ParentsParameter.ActualName = "Permutation";
+      Parameters.Add(new LookupParameter<Permutation>("Child", "The child permutation resulting from the crossover."));
+      ChildParameter.ActualName = "Permutation";
+
+      foreach (Type t in ApplicationManager.Manager.GetTypes(typeof(IPermutationCrossover))) {
+        if ((!typeof(PermutationCrossoverPointcut).IsAssignableFrom(t)) &&
+          (!typeof(MultiOperator<IPermutationCrossover>).IsAssignableFrom(t))) {
+          CrossoversParameter.ValidValues.Add((IPermutationCrossover)Activator.CreateInstance(t));
+        }
+      }
+
+      ParameterizeCrossovers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationCrossoverPointcut(this, cloner);
+    }
+
+    private void ParameterizeCrossovers() {
+      foreach (IPermutationCrossover crossover in CrossoversParameter.ValidValues.OfType<IPermutationCrossover>()) {
+        crossover.ChildParameter.ActualName = ChildParameter.Name;
+        crossover.ParentsParameter.ActualName = ParentsParameter.Name;
+      }
+      foreach (IStochasticOperator crossover in CrossoversParameter.ValidValues.OfType<IStochasticOperator>()) {
+        crossover.RandomParameter.ActualName = RandomParameter.Name;
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorCrossoverPointcut.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorCrossoverPointcut.cs	(revision 10098)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.SolutionCaching/3.3/RealVectorEncoding/RealVectorCrossoverPointcut.cs	(revision 10101)
@@ -35,14 +35,5 @@
   [Item("RealVectorCrossoverPointcut", "Wraps a crossover and applies after-crossover actions.")]
   [StorableClass]
-  public class RealVectorCrossoverPointcut : SingleSuccessorOperator, IRealVectorCrossover, IStochasticOperator, IRealVectorPointcut {
-    private const string AdviceParameterName = "Advice";
-    private const string CrossoversParameterName = "Crossovers";
-
-    public ConstrainedValueParameter<IRealVectorCrossover> CrossoversParameter {
-      get { return (ConstrainedValueParameter<IRealVectorCrossover>)Parameters[CrossoversParameterName]; }
-    }
-    public ConstrainedValueParameter<IRealVectorAdvice> AdviceParameter {
-      get { return (ConstrainedValueParameter<IRealVectorAdvice>)Parameters[AdviceParameterName]; }
-    }
+  public class RealVectorCrossoverPointcut : CrossoverPointcut<IRealVectorAdvice, IRealVectorCrossover>, IRealVectorCrossover, IRealVectorPointcut {
     public ILookupParameter<ItemArray<RealVector>> ParentsParameter {
       get { return (ScopeTreeLookupParameter<RealVector>)Parameters["Parents"]; }
@@ -54,7 +45,4 @@
       get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
     }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
 
     [StorableConstructor]
@@ -64,5 +52,10 @@
     public RealVectorCrossoverPointcut()
       : base() {
-      var cxs = new ConstrainedValueParameter<IRealVectorCrossover>(CrossoversParameterName, "The crossovers.");
+      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("Parents", "The parent vectors which should be crossed."));
+      ParentsParameter.ActualName = "RealVector";
+      Parameters.Add(new LookupParameter<RealVector>("Child", "The child vector resulting from the crossover."));
+      ChildParameter.ActualName = "RealVector";
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds of the real vector."));
+
       //Would be nicer if it comes from operator collection, but MultiRealVector Crossover does the same thing.
       //Also: MultiRealVectorCrossover cannot be used here as it would generate a cyclic recursion 
@@ -71,22 +64,7 @@
         if ((!typeof(RealVectorCrossoverPointcut).IsAssignableFrom(t)) &&
           (!typeof(MultiOperator<IRealVectorCrossover>).IsAssignableFrom(t))) {
-          cxs.ValidValues.Add((IRealVectorCrossover)Activator.CreateInstance(t));
+          CrossoversParameter.ValidValues.Add((IRealVectorCrossover)Activator.CreateInstance(t));
         }
       }
-      Parameters.Add(cxs);
-
-      var advices = new ConstrainedValueParameter<IRealVectorAdvice>(AdviceParameterName,
-        "Advice to introduce after crossover");
-      foreach (var a in ApplicationManager.Manager.GetInstances<IRealVectorAdvice>()) {
-        advices.ValidValues.Add(a);
-      }
-      Parameters.Add(advices);
-
-      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("Parents", "The parent vectors which should be crossed."));
-      ParentsParameter.ActualName = "RealVector";
-      Parameters.Add(new LookupParameter<RealVector>("Child", "The child vector resulting from the crossover."));
-      ChildParameter.ActualName = "RealVector";
-      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds of the real vector."));
-      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
 
       ParameterizeCrossovers();
@@ -95,18 +73,4 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       return new RealVectorCrossoverPointcut(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      IOperation successor = base.Apply();
-      IOperation crossoverOperation = ExecutionContext.CreateChildOperation(CrossoversParameter.Value);
-      IOperation adviceOperation = ExecutionContext.CreateChildOperation(AdviceParameter.Value);
-
-      var opCol = new OperationCollection();
-      opCol.Add(crossoverOperation);
-      opCol.Add(adviceOperation);
-      if (successor != null)
-        opCol.Add(successor);
-
-      return opCol;
     }
 